﻿' =======================================================
' Simple Shutdown Scheduler (SSS)
' Copyright (c) 2008-2009 Alain Descotes (violent_ken)
' https://sourceforge.net/projects/sshutdown/
' =======================================================


' SSS is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 3 of the License, or
' (at your option) any later version.
'
' SSS is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with SSS; if not, see http://www.gnu.org/licenses/.


Option Strict On

Imports System.Runtime.InteropServices
Imports Native.Api.NativeEnums

Namespace Native.Api

    Public Class NativeStructs

#Region "Declarations used for files"

        <StructLayout(LayoutKind.Sequential)> _
        Public Structure ShellExecuteInfo
            Public cbSize As Integer
            Public fMask As ShellExecuteInfoMask
            Public hwnd As IntPtr
            <MarshalAs(UnmanagedType.LPTStr)> Public lpVerb As String
            <MarshalAs(UnmanagedType.LPTStr)> Public lpFile As String
            <MarshalAs(UnmanagedType.LPTStr)> Public lpParameters As String
            <MarshalAs(UnmanagedType.LPTStr)> Public lpDirectory As String
            Dim nShow As ShowWindowType
            Dim hInstApp As IntPtr
            Dim lpIDList As IntPtr
            <MarshalAs(UnmanagedType.LPTStr)> Public lpClass As String
            Public hkeyClass As IntPtr
            Public dwHotKey As Integer
            Public hIcon As IntPtr
            Public hProcess As IntPtr
        End Structure

        <StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Unicode)> _
        Public Structure SHFILEOPSTRUCT
            Public hwnd As IntPtr
            Public wFunc As FO_Func
            Public pFrom As IntPtr
            Public pTo As IntPtr
            Public fFlags As FILEOP_FLAGS_ENUM
            Public fAnyOperationsAborted As Int32
            Public hNameMappings As IntPtr
            <MarshalAs(UnmanagedType.LPWStr)> _
            Public lpszProgressTitle As [String]
        End Structure

#End Region

#Region "Declarations used for token & privileges"

        <StructLayout(LayoutKind.Sequential)> _
        Public Structure Luid
            Dim lowpart As Integer
            Dim highpart As Integer
        End Structure

        <StructLayout(LayoutKind.Sequential)> _
        Public Structure LuidAndAttributes
            Dim pLuid As Luid
            Dim Attributes As NativeEnums.SePrivilegeAttributes
        End Structure

        <StructLayout(LayoutKind.Sequential)> _
        Public Structure PrivilegeInfo
            Dim Name As String
            Dim Status As SePrivilegeAttributes
            Dim pLuid As Luid
        End Structure

        <StructLayout(LayoutKind.Sequential)> _
        Public Structure TokenPrivileges
            Dim PrivilegeCount As Integer
            <MarshalAs(UnmanagedType.ByValArray)> _
            Dim Privileges() As LuidAndAttributes
        End Structure

#End Region

    End Class

End Namespace
